/* vi:set cindent: */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "pproxy.h"

int port = 8080;
int localhostonly = 1;

int
main (int argc, char **argv)
{
  int server_s;
  int s;
  struct sockaddr_in sin;
  struct sockaddr_in cliaddr;
  int cliaddr_len = sizeof (cliaddr);
  int on = 1;

  init_sighandlers ();

  sin.sin_family = AF_INET;
  sin.sin_addr.s_addr = htonl (INADDR_ANY);
  sin.sin_port = htons (port);

  if ((server_s = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    {
      perror ("scoket");
      exit (1);
    }

  if (setsockopt (server_s, SOL_SOCKET, SO_REUSEADDR, &on, sizeof (on)) < 0)
    {
      perror ("setsockopt(SO_REUSEADDR)");
      exit (1);
    }

  if (bind (server_s, (struct sockaddr *) &sin, sizeof (sin)) < 0)
    {
      perror ("bind");
      exit (1);
    }

  if (listen (server_s, 3) < 0)
    {
      perror ("listen");
      exit (1);
    }

  while (1)
    {
      if ((s = accept (server_s, (struct sockaddr *) &cliaddr, &cliaddr_len)) < 0)
	{
	  perror ("accept");
	  exit (1);
	}

      if (fork () == 0)
	{
	  close (server_s);
	  do_request (s, (struct sockaddr *)&cliaddr, cliaddr_len);
	  exit (0);
	}
      close (s);
    }				/* while (1) */
}
