#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

unsigned long int
resolve (char *hostname)
{
  struct hostent *hp;
  unsigned long int ip;

  if (hostname == NULL)
    return INADDR_NONE;
  if (*hostname == 0)
    return INADDR_NONE;

  ip = inet_addr (hostname);
  if (ip != INADDR_NONE)
    return ip;

  if ((hp = gethostbyname (hostname)) == NULL)
    return INADDR_NONE;

  memcpy (&ip, hp->h_addr, hp->h_length);
  return ip;
}

int 
sockprintf (int socket, char *format,...)
{
  va_list ap;
  char buf[10240];

  va_start (ap, format);
  vsnprintf (buf, 10240, format, ap);
  va_end (ap);
  return write (socket, buf, strlen (buf));
}

int
sockgets (int socket, char *buf, int len)
{
  while (--len)
    {
      if (read (socket, buf, 1) != 1)
	return -1;
      if (*buf == '\n')
	break;
      if (*buf != '\r')		/* remove all CRs */
	buf++;
    }
  *buf = 0;
  return 0;
}

/* XXX: To je ale hnus ... */
int 
maketree (char *path)
{
  int i;

  if (path == NULL)
    return -1;

  for (i = 0; i < strlen (path); i++)
    {
      if (path[i] == '/' && i != 0)
	{
	  path[i] = 0;
	  mkdir (path, 0755);
	  path[i] = '/';
	}
    }

  mkdir (path, 0755);
}
